//Do not edit! This file was generated by Unity-ROS MessageGeneration.
using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Unity.Robotics.ROSTCPConnector.MessageGeneration;

namespace RosMessageTypes.Server
{
    [Serializable]
    public class LookattargetGoal : Message
    {
        public const string k_RosMessageName = "hlrc_server/lookattargetGoal";
        public override string RosMessageName => k_RosMessageName;

        public Geometry.PointStampedMsg point;
        //  roll angle
        public float roll;

        public LookattargetGoal()
        {
            this.point = new Geometry.PointStampedMsg();
            this.roll = 0.0f;
        }

        public LookattargetGoal(Geometry.PointStampedMsg point, float roll)
        {
            this.point = point;
            this.roll = roll;
        }

        public static LookattargetGoal Deserialize(MessageDeserializer deserializer) => new LookattargetGoal(deserializer);

        private LookattargetGoal(MessageDeserializer deserializer)
        {
            this.point = Geometry.PointStampedMsg.Deserialize(deserializer);
            deserializer.Read(out this.roll);
        }

        public override void SerializeTo(MessageSerializer serializer)
        {
            serializer.Write(this.point);
            serializer.Write(this.roll);
        }

        public override string ToString()
        {
            return "LookattargetGoal: " +
            "\npoint: " + point.ToString() +
            "\nroll: " + roll.ToString();
        }

#if UNITY_EDITOR
        [UnityEditor.InitializeOnLoadMethod]
#else
        [UnityEngine.RuntimeInitializeOnLoadMethod]
#endif
        public static void Register()
        {
            MessageRegistry.Register(k_RosMessageName, Deserialize, MessageSubtopic.Goal);
        }
    }
}
